<template>
  <button
    :class="{
      btn: true,
      'btn-primary': !subscribed,
      'btn-outline-secondary': subscribed,
    }"
    @click="onClickSubscribe"
    :disabled="subscriptionPending"
  >
    {{ subscribeButtonText }}
    <span v-if="subscriptionPending" class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
    <i v-else aria-hidden="true" :class="iconClass"></i>
  </button>
</template>

<script>
import { ref, computed } from 'vue'
import { useApi, useNotification } from '../../core'
import { useAuth } from '../../identity'
import TopicsApi from '../api/topics-api.js'

export default {
  name: 'TopicSubscriptionButton',
  emits: ['subscribed', 'unsubscribed'],
  props: {
    topic: { type: Object, required: true },
  },
  setup(props, context) {
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const topicsApi = new TopicsApi(api, auth)

    const subscriptionPending = ref(false)

    const subscribed = computed(() => {
      return props.topic.subscribed
    })

    const subscribeButtonText = computed(() => {
      return subscribed.value
        ? subscriptionPending.value
          ? 'Unsubscribing...'
          : 'Subscribed'
        : subscriptionPending.value
        ? 'Subscribing...'
        : 'Subscribe'
    })

    const iconClass = computed(() => {
      return subscribed.value ? 'bi bi-star-fill' : 'bi bi-star'
    })

    const onClickSubscribe = async () => {
      if (subscribed.value) {
        await unsubscribeAsync()
      } else {
        await subscribeAsync()
      }
    }

    const subscribeAsync = async () => {
      subscriptionPending.value = true

      try {
        await topicsApi.subscribeAsync(props.topic.id)
        context.emit('subscribed', props.topic.id)
      } catch (ex) {
        notify.error('There was a problem subscribing to the topic.', ex)
      } finally {
        subscriptionPending.value = false
      }
    }

    const unsubscribeAsync = async () => {
      subscriptionPending.value = true

      try {
        await topicsApi.unsubscribeAsync(props.topic.id)
        context.emit('unsubscribed', props.topic.id)
      } catch (ex) {
        notify.error('There was a problem unsubscribing from the topic.', ex)
      } finally {
        subscriptionPending.value = false
      }
    }

    return {
      subscriptionPending,
      subscribed,
      subscribeButtonText,
      iconClass,
      onClickSubscribe,
    }
  },
}
</script>
